/*===========================================================================*/
static void gettagrsn(size_t c, int infolen, u8 *infostart)
{
static iersn_t *rsn;
static rsnsuite_t *rsnsuite;

(aplist +c)->groupcipher = 0;
rsn = (iersn_t*)infostart;
if(rsn->version != 1) return;
rsnsuite =(rsnsuite_t*)(infostart + IERSN_SIZE);
if(memcmp(&rsnsuiteoui, rsnsuite->oui, 3) != 0) return;
(aplist +c)->groupcipher = rsnsuite->type;
printf("RSN %d %d\n", infolen, (aplist +c)->groupcipher);


return;
}
/*---------------------------------------------------------------------------*/
static void tagwalk_channel_essid_rsn(size_t c, int infolen, u8 *infostart)
{
static ietag_t *infoptr;

(aplist +c)->channel = scanlistchannel[scanlistcount];
while(0 < infolen)
	{
	infoptr = (ietag_t*)infostart;
	if(infolen < (int)(infoptr->len + IETAG_SIZE)) return;
	if(infoptr->id == TAG_SSID)
		{
		if((infoptr->len > 0) && (infoptr->len <= ESSID_MAX))
			{
			(aplist +c)->essidlen = infoptr->len;
			printf("%.*s\n",infoptr->len, &infoptr->data[0]);
			memcpy((aplist +c)->essid, &infoptr->data[0], infoptr->len);
			}
		}
	else if(infoptr->id == TAG_CHAN)
		{
		if(infoptr->len == 1) (aplist +c)->channel = (u16)infoptr->data[0];
		}
	else if(infoptr->id == TAG_RSN)
		{
		if(infoptr->len >= IERSN_LEN_MIN) gettagrsn(c, infoptr->len, infoptr->data);
		return;
		}
	infostart += infoptr->len +IETAG_SIZE;
	infolen -= infoptr->len +IETAG_SIZE;
	}
return;
}
/*===========================================================================*/
static inline void process80211blockackreq()
{
static size_t c;

for(c = 0; c < APLIST_MAX - 1; c++)
	{
	if(memcmp(macfrx->addr1, (aplist + c)->mac, 6) == 0)
		{
		if(memcmp((aplist + c)->macclient, macfrx->addr2, 6) == 0) return;
			{
			memcpy((aplist + c)->macclient, macfrx->addr2, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;
			}
		return;
		}
	if(memcmp(macfrx->addr2, (aplist + c)->mac, 6) == 0)
		{
		if(memcmp((aplist + c)->macclient, macfrx->addr1, 6) == 0) return;
			{
			memcpy((aplist + c)->macclient, macfrx->addr1, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;
			}
		return;
		}
	}
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211blockack()
{
static size_t c;

for(c = 0; c < APLIST_MAX - 1; c++)
	{
	if(memcmp(macfrx->addr1, (aplist + c)->mac, 6) == 0)
		{
		if((aplist + c)->status >= AP_EAPOL_OK) return;
		if(memcmp((aplist + c)->macclient, macfrx->addr2, 6) == 0) return;
			{
			memcpy((aplist + c)->macclient, macfrx->addr2, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;

			}
		return;
		}
	if(memcmp(macfrx->addr2, (aplist + c)->mac, 6) == 0)
		{
		if((aplist + c)->status >= AP_EAPOL_OK) return;
		if(memcmp((aplist + c)->macclient, macfrx->addr1, 6) == 0) return;
			{
			memcpy((aplist + c)->macclient, macfrx->addr1, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;
			}
		return;
		}
	}
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211vht()
{
static size_t c;

for(c = 0; c < APLIST_MAX - 1; c++)
	{
	if(memcmp(macfrx->addr1, (aplist + c)->mac, 6) == 0)
		{
		if((aplist + c)->status >= AP_EAPOL_OK) return;
		if(memcmp((aplist + c)->macclient, macfrx->addr2, 6) == 0) return;
			{
			memcpy((aplist + c)->macclient, macfrx->addr2, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;
			}
		return;
		}
	if(memcmp(macfrx->addr2, (aplist + c)->mac, 6) == 0)
		{
		if((aplist + c)->status >= AP_EAPOL_OK) return;
		if(memcmp((aplist + c)->macclient, macfrx->addr1, 6) == 0) return;
			{
			memcpy((aplist + c)->macclient, macfrx->addr1, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;
			}
		return;
		}
	}
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211pspoll()
{
static size_t c;

for(c = 0; c < APLIST_MAX - 1; c++)
	{
	if(memcmp(macfrx->addr1, (aplist + c)->mac, 6) == 0)
		{
		if((aplist + c)->status >= AP_EAPOL_OK) return;
		if(memcmp((aplist + c)->macclient, macfrx->addr2, 6) == 0) return;
			{
			memcpy((aplist + c)->macclient, macfrx->addr2, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;
			}
		return;
		}
	}
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211qosnull()
{
static size_t c;

for(c = 0; c < APLIST_MAX - 1; c++)
	{
	if(memcmp(macfrx->addr3, (aplist + c)->mac, 6) == 0)
		{
		if((aplist + c)->status >= AP_EAPOL_OK) return;
		if(macfrx->from_ds == 1)
			{
			memcpy((aplist + c)->macclient, macfrx->addr1, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;
			}
		
		else if(macfrx->to_ds == 1)
			{
			memcpy((aplist + c)->macclient, macfrx->addr2, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;
			}
		return;
		}
	}
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211null()
{
static size_t c;

for(c = 0; c < APLIST_MAX - 1; c++)
	{
	if(memcmp(macfrx->addr3, (aplist + c)->mac, 6) == 0)
		{
		if((aplist + c)->status >= AP_EAPOL_OK) return;
		if(macfrx->from_ds == 1)
			{
			memcpy((aplist + c)->macclient, macfrx->addr1, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;
			}
		
		else if(macfrx->to_ds == 1)
			{
			memcpy((aplist + c)->macclient, macfrx->addr2, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;
			}
		return;
		}
	}
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211action()
{
static size_t c;
static action_t *apinfo;

for(c = 0; c < APLIST_MAX - 1; c++)
	{
	if(memcmp(macfrx->addr3, (aplist + c)->mac, 6) == 0)
		{
		if(memcmp(macfrx->addr2, macfrx->addr3, 6) == 0)
			{
			memcpy((aplist + c)->macclient, macfrx->addr1, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;
			break;
			}
		if(memcmp(macfrx->addr1, macfrx->addr3, 6) == 0)
			{
			memcpy((aplist + c)->macclient, macfrx->addr2, 6);
			(aplist + c)->tsinterval1 = tsakt;
			(aplist + c)->count1 = 4;
			}
		break;
		}
	}

apinfo = (action_t*)payloadptr;
if(payloadlen < (ACTION_SIZE + IETAG_SIZE)) return;
if(apinfo->category == RADIO_MEASUREMENT) writeepb();
return;
}
/*===========================================================================*/
static inline void process80211proberequest_directed()
{


writeepb();
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211proberequest_undirected()
{


writeepb();
return;
}
/*===========================================================================*/
static inline void process80211proberesponse()
{
static size_t c;
static u16 clientinfolen;
static u8 *clientinfoptr;

clientinfoptr = payloadptr +CAPABILITIESCLIENT_SIZE;
clientinfolen = payloadlen -CAPABILITIESCLIENT_SIZE;
if(clientinfolen < IETAG_SIZE) return;
for(c = 0; c < APLIST_MAX - 1; c++)
	{
	if(memcmp(macfrx->addr3, (proberesponselist + c)->mac, 6) != 0) continue;
	(proberesponselist + c)->tsakt = tsakt;
	if((proberesponselist + c)->status >= AP_EAPOL_OK) return;
	if((proberesponselist + c)->count1 == 0) return;
	return;
	}
memset((proberesponselist + c), 0, APLIST_SIZE);
(proberesponselist + c)->tsakt = tsakt;
(proberesponselist + c)->tsinterval1= tsakt;
(proberesponselist + c)->count1 = 4;
memcpy((proberesponselist + c)->mac, macfrx->addr3, 6);
qsort(proberesponselist, c + 1, APLIST_SIZE, sort_aplist_by_tsakt);
writeepb();
return;
}
/*===========================================================================*/
static inline void process80211beacon()
{
static size_t c;
static u16 apinfolen;
static u8 *apinfoptr;

apinfoptr = payloadptr +CAPABILITIESAP_SIZE;
apinfolen = payloadlen -CAPABILITIESAP_SIZE;
if(apinfolen < IETAG_SIZE) return;
for(c = 0; c < APLIST_MAX - 1; c++)
	{
	if(memcmp(macfrx->addr3, (aplist + c)->mac, 6) != 0) continue;
	(aplist + c)->tsakt = tsakt;
	if((aplist + c)->status >= AP_EAPOL_OK) return;
	if((aplist + c)->count1 == 0) return;
	if((tsakt - authseqakt.tsfirst) < STAYTIMEPLUS) return;
	if(((aplist + c)->tsakt - (aplist + c)->tsinterval1) < TSTIMER1) return;
	tagwalk_channel_essid_rsn(c, apinfolen, apinfoptr);
	if((aplist + c)->channel != scanlistchannel[scanlistcount]) return;
	(aplist + c)->tsinterval1 = tsakt;
	(aplist + c)->count1 -= 1;
	if(deauthenticationflag == true) send_80211_deauthentication((aplist + c)->macclient, WLAN_REASON_CLASS3_FRAME_FROM_NONASSOC_STA);
	return;
	}
memset((aplist + c), 0, APLIST_SIZE);
(aplist + c)->tsakt = tsakt;
memcpy((aplist + c)->mac, macfrx->addr3, 6);
memcpy((aplist + c)->macclient, &macbc, 6);
tagwalk_channel_essid_rsn(c, apinfolen, apinfoptr);
(aplist + c)->tsinterval1= tsakt;
(aplist + c)->count1 = 4;
if((aplist + c)->channel == scanlistchannel[scanlistcount])
	{
	if(deauthenticationflag == true) send_80211_deauthentication(macbc, WLAN_REASON_CLASS3_FRAME_FROM_NONASSOC_STA);
	}
qsort(aplist, c + 1, APLIST_SIZE, sort_aplist_by_tsakt);
writeepb();
return;
}
/*===========================================================================*/
static inline int getkeyinfo(uint16_t kyif)
{
if(kyif & WPA_KEY_INFO_ACK)
	{
	if(kyif & WPA_KEY_INFO_INSTALL) return 3; /* handshake 3 */
	else return 1; /* handshake 1 */
	}
else
	{
	if(kyif & WPA_KEY_INFO_SECURE) return 4; /* handshake 4 */
	else return 2; /* handshake 2 */
	}
return 0;
}
/*---------------------------------------------------------------------------*/
static inline void process80211eapol_m1()
{
static size_t c;
static pmkid_t *pmkid;

authseqakt.tsfirst = tsakt;
printf("debug M1 in %04x\n", wpakey->keyinfo);
memset(&authseqakt, 0, AUTHSEQAKT_SIZE);
memcpy(&authseqakt.macap, macfrx->addr2, 6);
authseqakt.kvm1 = ntohs(wpakey->keyinfo) & WPA_KEY_INFO_TYPE_MASK;
authseqakt.replaycountm1 = be64toh(wpakey->replaycount);
memcpy(&authseqakt.noncem1, &wpakey->nonce[28], 4);
authseqakt.status = AP_EAPOL_M1;
if(ntohs(wpakey->wpadatalen) == PMKID_SIZE)
	{
	pmkid = (pmkid_t*)(eapolplptr +WPAKEY_SIZE);
	if(memcmp(&rsnsuiteoui, pmkid->oui, 3) == 0)
		{
		if(pmkid->len >= 0x14)
			{
			if(pmkid->type == 0x04)
				{
				if(memcmp(pmkid->pmkid, &zeroed, PMKID_MAX) == 0)
				authseqakt.status |= AP_PMKID;
				printf("got PMKID\n");
				}
			}
		}
	}
for(c = 0; c < APLIST_MAX - 1; c++)
	{
	if(memcmp((aplist + c)->mac, authseqakt.macap, 6) == 0)
		{
		(aplist + c)->status = authseqakt.status;
		return;
		}
	}
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211eapol_m2()
{
printf("debug M2, %d\n", authseqakt.status);

authseqakt.replaycountm2 = be64toh(wpakey->replaycount);
if(valakt.replaycount == authseqakt.replaycountm2)
	{
	authseqakt.status = 0;
	return;
	}

if((authseqakt.status & AP_EAPOL_M1) == AP_EAPOL_M1)
	{
	if(memcmp(&authseqakt.macap, macfrx->addr1, 6) == 0)
		{
		if(authseqakt.replaycountm1 == authseqakt.replaycountm2)
			{
			authseqakt.kvm2 = ntohs(wpakey->keyinfo) & WPA_KEY_INFO_TYPE_MASK;
			if(authseqakt.kvm1 == authseqakt.kvm2)
				{
				printf("m2 timeout  %" PRIu64 "\n", tsakt - authseqakt.tsfirst);
				if((tsakt - authseqakt.tsfirst) < EAPOLM2TIMEOUT)
					{
					authseqakt.status |= AP_EAPOL_M2;
					return;
					}
				}
			}
		}
	}
authseqakt.status = 0;
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211eapol_m3()
{
static size_t c;
printf("debug M3, %d\n", authseqakt.status);

if((authseqakt.status & AP_EAPOL_M2) == AP_EAPOL_M2)
	{
	if(memcmp(&authseqakt.macap, macfrx->addr2, 6) == 0)
		{
		if(authseqakt.replaycountm2 == (be64toh(wpakey->replaycount) - 1))
			{
			if(authseqakt.kvm2 == (ntohs(wpakey->keyinfo) & WPA_KEY_INFO_TYPE_MASK))
				{
				printf("m3 timeout  %" PRIu64 "\n", tsakt - authseqakt.tsfirst);
				if((tsakt - authseqakt.tsfirst) < EAPOLM3TIMEOUT)
					{
					if(memcmp(&authseqakt.noncem1, &wpakey->nonce[28], 4) == 0)
						{
						for(c = 0; c < APLIST_MAX -1; c++)
							{
							if(memcmp((aplist + c)->mac, authseqakt.macap, 6) == 0)
								{
								(aplist + c)->status = authseqakt.status;
								(aplist + c)->status |= AP_EAPOL_M3;
								printf("got handshake\n");
								memset(&authseqakt, 0, AUTHSEQAKT_SIZE);
								return;
								}
							}
						}
					}
				}
			}
		}
	}
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211eapol()
{
static u16 keyinfo;

eapolplptr = eapauthplptr +EAPAUTH_SIZE;
eapolpllen = eapauthpllen -EAPAUTH_SIZE;
if((eapolpllen + EAPAUTH_SIZE + LLC_SIZE) > payloadlen) return;
wpakey = (wpakey_t*)eapolplptr;
keyinfo = (getkeyinfo(ntohs(wpakey->keyinfo)));
switch(keyinfo)
	{
	case M1:
	process80211eapol_m1();
	break;

	case M2:
	process80211eapol_m2();
	break;

	case M3:
	process80211eapol_m3();
	break;
	}
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211eapauthentication()
{
authseqakt.tsfirst = tsakt;
eapauthplptr = payloadptr +LLC_SIZE;
eapauthpllen = payloadlen -LLC_SIZE;
eapauth = (eapauth_t*)eapauthplptr;
eapauthlen = ntohs(eapauth->len);
if(eapauthlen > (eapauthpllen -EAPAUTH_SIZE)) return;
if(eapauth->type == EAPOL_KEY) process80211eapol();
/*
else if(auth->type == EAP_PACKET) process80211exteap(authlen);
else if(auth->type == EAPOL_START) 
	{
	send_eap_request_id(macfrx->addr2, macfrx->addr1);
	}
*/
writeepb();
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211reassociationresponse()
{
authseqakt.tsfirst = tsakt;
memcpy(&authseqakt.macap, macfrx->addr2, 6);



writeepb();
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211reassociationrequest()
{
authseqakt.tsfirst = tsakt;
memcpy(&authseqakt.macap, macfrx->addr1, 6);



writeepb();
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211associationresponse()
{
authseqakt.tsfirst = tsakt;
memcpy(&authseqakt.macap, macfrx->addr2, 6);


writeepb();
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211associationrequest()
{
authseqakt.tsfirst = tsakt;
memcpy(&authseqakt.macap, macfrx->addr1, 6);



writeepb();
return;
}
/*---------------------------------------------------------------------------*/
static inline void process80211authentication()
{
authseqakt.tsfirst = tsakt;



writeepb();
return;
}
/*===========================================================================*/
static inline void process_packet()
{
static u16 rthlen;

if((packetlen = read(fd_socket_rx, epb +EPB_SIZE, PCAPNG_SNAPLEN)) < RTRXHDR_SIZE)
	{
	if(packetlen == - 1) errorcount++;
	return;
	}
if((rth->it_present & IEEE80211_RADIOTAP_FLAGS) == 0) return;
rthlen = le16toh(rth->it_len);
if(rthlen > packetlen)
	{
	errorcount++;
	return;
	}
ieee82011ptr = packetptr +rthlen;
ieee82011len = packetlen -rthlen;
if(ieee82011len <= MAC_SIZE_RTS) return;
gettimeofday(&tvakt, NULL);
tsakt = ((u64)tvakt.tv_sec * 1000000ULL) + tvakt.tv_usec;
macfrx = (mac_t*)ieee82011ptr;
if((macfrx->from_ds == 1) && (macfrx->to_ds == 1))
	{
	payloadptr = ieee82011ptr +MAC_SIZE_LONG;
	payloadlen = ieee82011len -MAC_SIZE_LONG;
	}
else
	{
	payloadptr = ieee82011ptr +MAC_SIZE_NORM;
	payloadlen = ieee82011len -MAC_SIZE_NORM;
	}
if(macfrx->type == IEEE80211_FTYPE_MGMT)
	{
	if(macfrx->subtype == IEEE80211_STYPE_BEACON) process80211beacon();
	else if(macfrx->subtype == IEEE80211_STYPE_PROBE_RESP) process80211proberesponse();
	else if(macfrx->subtype == IEEE80211_STYPE_PROBE_REQ)
		{
		if(memcmp(macfrx->addr3, macbc, 6) == 0) process80211proberequest_undirected();
		else process80211proberequest_directed();
		}
	else if(macfrx->subtype == IEEE80211_STYPE_AUTH) process80211authentication();
	else if(macfrx->subtype == IEEE80211_STYPE_ASSOC_REQ) process80211associationrequest();
	else if(macfrx->subtype == IEEE80211_STYPE_ASSOC_RESP) process80211associationresponse();
	else if(macfrx->subtype == IEEE80211_STYPE_REASSOC_REQ)process80211reassociationrequest();
	else if(macfrx->subtype == IEEE80211_STYPE_REASSOC_RESP) process80211reassociationresponse();
	}
else if(macfrx->type == IEEE80211_FTYPE_CTL)
	{
	if(macfrx->subtype == IEEE80211_STYPE_BACK) process80211blockack();
	else if(macfrx->subtype == IEEE80211_STYPE_BACK_REQ) process80211blockackreq();
	else if(macfrx->subtype == IEEE80211_STYPE_VHT) process80211vht();
	else if(macfrx->subtype == IEEE80211_STYPE_PSPOLL) process80211pspoll();
	}
else if(macfrx->type == IEEE80211_FTYPE_DATA)
	{
	if((macfrx->subtype &IEEE80211_STYPE_NULLFUNC) == IEEE80211_STYPE_NULLFUNC)process80211null();
	else if((macfrx->subtype &IEEE80211_STYPE_QOS_NULLFUNC) == IEEE80211_STYPE_QOS_NULLFUNC) process80211qosnull();

	else if((macfrx->subtype &IEEE80211_STYPE_QOS_DATA) == IEEE80211_STYPE_QOS_DATA)
		{
		payloadptr += QOS_SIZE;
		payloadlen -= QOS_SIZE;
		}
	else if(payloadlen < LLC_SIZE) return;
	llcptr = payloadptr;
	llc = (llc_t*)llcptr;
	if(((ntohs(llc->type)) == LLC_TYPE_AUTH) && (llc->dsap == LLC_SNAP) && (llc->ssap == LLC_SNAP)) process80211eapauthentication();
	}
return;
}
/*===========================================================================*/
