/*===========================================================================*/
static bool set_interface_up()
{
if(set_rt_interface_down(IFF_UP) == false)
	{
	if(set_ioctl_interface_up() == false) return false;
	}
return true;
}
/*===========================================================================*/
static bool set_interface_down()
{
if(set_rt_interface_down(0) == false)
	{
	if(set_ioctl_interface_down() == false) return false;
	}
return true;
}
/*===========================================================================*/
static ifinfo_t* getinterface(unsigned int ifindex)
{
size_t c;

ifakt = NULL;
qsort(iflist, ifc, IFINFOLIST_SIZE, sort_iflist_by_iftype);
if(ifindex != 0)
	{
	for(c = 0; c < ifc; c++)
		{
		if((iflist +c)->ifindex == ifindex)
			{
			if((iflist +c)->iftype != 0) return (iflist +c);
			else return NULL;
			}
		}
	}
else
	{
	for(c = 0; c < ifc; c++)
		{
		if((iflist +c)->ifindex == 0) continue;
		if((iflist +c)->iftype != 0) return (iflist +c);
		}
	}
return NULL;
}
/*===========================================================================*/
static bool request_ioctl_interfaces()
{
size_t c;
struct iwreq pwrq;
struct ifreq ifrq;
struct ethtool_perm_addr *epa = NULL;
struct ethtool_drvinfo edr;
const char *protocol80211 = "IEEE 802.11";

if((fd_socket_ioctl = socket(AF_UNIX, SOCK_DGRAM, 0)) < 0) return false;
for(c = 0; c < ifc; c++)
	{
	memset(&pwrq, 0, sizeof(pwrq));
	memcpy(pwrq.ifr_name, (iflist +c)->ifname, IFNAMSIZ);
	if(ioctl(fd_socket_ioctl, SIOCGIWNAME, &pwrq) != -1)
		{
		if(strncmp(protocol80211, pwrq.u.name, IFNAMSIZ) == 0) (iflist +c)->iftype |= IFTYPEWE;
		}
	epa = (struct ethtool_perm_addr*) malloc(sizeof(struct ethtool_perm_addr) + IFHWADDRLEN);
	epa->cmd = ETHTOOL_GPERMADDR;
	epa->size = IFHWADDRLEN;
	memset(&ifrq, 0, sizeof(ifrq));
	memcpy(ifrq.ifr_name, (iflist +c)->ifname, IFNAMSIZ);
	ifrq.ifr_data = (caddr_t)epa;
	if(ioctl(fd_socket_ioctl, SIOCETHTOOL, &ifrq) != -1) memcpy((iflist +c)->hwmac, epa->data, IFHWADDRLEN);
	free(epa);

	edr.cmd = ETHTOOL_GDRVINFO;
	memset(&ifrq, 0, sizeof(ifrq));
	memcpy(ifrq.ifr_name, (iflist +c)->ifname, IFNAMSIZ);
	ifrq.ifr_data = (caddr_t)&edr;
	if(ioctl(fd_socket_ioctl, SIOCETHTOOL, &ifrq) != -1)
		{
		strncpy((iflist +c)->driver, edr.driver, ETHTOOL_STD_LEN);
		strncpy((iflist +c)->version, edr.version, ETHTOOL_STD_LEN);
		strncpy((iflist +c)->fw_version, edr.fw_version, ETHTOOL_FWVERS_LEN);
		strncpy((iflist +c)->bus_info, edr.bus_info, ETHTOOL_BUSINFO_LEN);
		strncpy((iflist +c)->erom_version, edr.erom_version, ETHTOOL_EROMVERS_LEN);
		}
	}
return true;
}
/*===========================================================================*/
static bool getwlaninterfaces()
{
if(request_nl80211_family() == false) return false;
if(nlfamily == 0) return false;
if(request_nl80211_protocolfeatures() == false) return false;
if(request_nl80211_interfaces() == false) return false;
if(request_nl80211_interfacefeature() != 0) return false;
if(request_ioctl_interfaces() == false) return false;
return true;
}
/*===========================================================================*/
static bool set_monitor_mode()
{
if(set_nl80211_monitor_mode() == false)
	{
	if(set_ioctl_monitor_mode() == false) return false;
	}
return true;
}
/*===========================================================================*/
