/*===========================================================================*/
static bool initrpigpio(unsigned int gpioperi)
{
int fd_devinfo;

if((fd_devinfo = open("/dev/mem", O_RDWR | O_SYNC)) < 0)
	{
	fprintf(stderr, "failed to get device memory\n");
	return false;
	}
gpio_map = mmap(NULL, BLOCK_SIZE, PROT_READ|PROT_WRITE, MAP_SHARED, fd_devinfo, gpioperi);
close(fd_devinfo);
if(gpio_map == MAP_FAILED)
	{
	fprintf(stderr, "failed to map GPIO memory\n");
	return false;
	}
gpio = (volatile unsigned *)gpio_map;
return true;
}
/*---------------------------------------------------------------------------*/
static unsigned int getrpigpiobasemem()
{
FILE *procinfo;
int len = 0;
bool rpi = false;
unsigned int gpioperibase = 0;
char linein[RASPBERRY_INFO] = { 0 };

if((procinfo = fopen("/proc/cpuinfo", "r")) == NULL)
	{
	perror("failed to retrieve cpuinfo");
	return gpioperibase;
	}
while(1)
	{
	if((len = fgetline(procinfo, RASPBERRY_INFO, linein)) == -1) break;
	if(len < 18) continue;
	if(strstr(linein, "Raspberry Pi")) rpi = true;
	if(strstr(linein, "Serial") != NULL)
		{
		if(len > 8) seed += strtoul(&linein[len -6], NULL, 16);
		}
	}
fclose(procinfo);
if(rpi == false) return gpioperibase;
if((procinfo = fopen("/proc/iomem", "r")) == NULL)
	{
	perror("failed to retrieve iomem");
	return gpioperibase;
	}
while(1)
	{
	if((len = fgetline(procinfo, RASPBERRY_INFO, linein)) == -1) break;
	if(strstr(linein, ".gpio") != NULL)
		{
		if(linein[8] != '-') break;
			{
			linein[8] = 0;
			gpioperibase = strtoul(linein, NULL, 16);
			break;
			}
		}
	}
fclose(procinfo);
return gpioperibase;
}
/*---------------------------------------------------------------------------*/
static bool initrpi()
{
unsigned int gpiobasemem;

gpiobasemem = getrpigpiobasemem();
if(gpiobasemem == 0)
	{
	fprintf(stderr, "failed to locate GPIO\n");
	return false;
	}
if(initrpigpio(gpiobasemem) == false)
	{
	fprintf(stderr, "failed to init GPIO\n");
	return false;
	}
if(gpiostatusled > 0)
	{
	INP_GPIO(gpiostatusled);
	OUT_GPIO(gpiostatusled);
	}
if(gpiobutton > 0) INP_GPIO(gpiobutton);
return true;
}
/*===========================================================================*/
