/*===========================================================================*/
static void handle_signals(int signum)
{
if((signum == SIGINT) || (signum == SIGTERM) || (signum == SIGKILL)  || (signum == SIGSTOP)  || (signum == SIGQUIT) || (signum ==  SIGTSTP))
	{
	wantstopflag = true;
	buttonflag = true;
	}
return;
}
/*===========================================================================*/
static bool fd_scan(bool activebeaconflag)
{
int epn = 0;
int c;
struct sigaction sa;
sigset_t allsigs;
sigset_t emptysigs;
int fd_timer1 = 0; /* BEACON */
int fd_timer2 = 0; /* staytime on frequency */
int fd_timer3 = 0; /* LED */
int fd_timer4 = 0; /* tot */
int fd_epoll = 0;
int epc = 0;
struct epoll_event ev, events[EPOLL_EVENTS_MAX];

struct itimerspec tval1;
struct itimerspec tval2;
struct itimerspec tval3;
struct itimerspec tval4;
static struct timespec sleepled;
u64 exp = 0;

sleepled.tv_sec = 0;
sleepled.tv_nsec = GPIO_LED_DELAY;
sigfillset(&allsigs);
sigemptyset(&emptysigs);
sa.sa_handler = handle_signals;
sa.sa_mask = allsigs;
sigaction(SIGINT, &sa, NULL);
sigaction(SIGTERM, &sa, NULL);
sigaction(SIGKILL, &sa, NULL);
sigaction(SIGSTOP, &sa, NULL);
sigaction(SIGTSTP, &sa, NULL);

if((fd_epoll= epoll_create(1)) < 0) return false;
ev.data.fd = fd_socket_rx;
ev.events = EPOLLIN | EPOLLET;
if(epoll_ctl(fd_epoll, EPOLL_CTL_ADD, fd_socket_rx, &ev) < 0) return false;
epc++;

if(activebeaconflag == true)
	{
	if((fd_timer1 = timerfd_create(CLOCK_BOOTTIME, 0)) <0 ) return false;
	tval1.it_value.tv_nsec = FDUSEC1;
	tval1.it_interval.tv_nsec = FDUSEC1;
	tval1.it_value.tv_sec = 0;
	tval1.it_interval.tv_sec = 0;
	if(timerfd_settime(fd_timer1, 0, &tval1, NULL) == -1) return false;
	ev.data.fd = fd_timer1;
	ev.events = EPOLLIN | EPOLLET;
	if(epoll_ctl(fd_epoll, EPOLL_CTL_ADD, fd_timer1, &ev) < 0) return false;
	epc++;
	}

if(staytime > 0)
	{
	if((fd_timer2 = timerfd_create(CLOCK_BOOTTIME, 0)) <0 ) return false;
	tval2.it_value.tv_sec = staytime;
	tval2.it_value.tv_nsec = 0;
	tval2.it_interval.tv_sec = staytime;
	tval2.it_interval.tv_nsec = 0;
	if(timerfd_settime(fd_timer2, 0, &tval2, NULL) == -1) return false;
	ev.data.fd = fd_timer2;
	ev.events = EPOLLIN | EPOLLET;
	if(epoll_ctl(fd_epoll, EPOLL_CTL_ADD, fd_timer2, &ev) < 0) return false;
	epc++;
	}

if((gpiostatusled + gpiobutton) > 0)
	{
	if((fd_timer3 = timerfd_create(CLOCK_BOOTTIME, 0)) <0 ) return false;
	tval3.it_value.tv_sec = FDSEC2;
	tval3.it_value.tv_nsec = 0;
	tval3.it_interval.tv_sec = FDSEC2;
	tval3.it_interval.tv_nsec = 0;
	if(timerfd_settime(fd_timer3, 0, &tval3, NULL) == -1) return false;
	ev.data.fd = fd_timer3;
	ev.events = EPOLLIN | EPOLLET;
	if(epoll_ctl(fd_epoll, EPOLL_CTL_ADD, fd_timer3, &ev) < 0) return false;
	epc++;
	}

if(tottime > 0)
	{
	if((fd_timer4 = timerfd_create(CLOCK_BOOTTIME, 0)) <0 ) return false;
	tval4.it_value.tv_sec = tottime;
	tval4.it_value.tv_nsec = 0;
	tval4.it_interval.tv_sec = 0;
	tval4.it_interval.tv_nsec = 0;
	if(timerfd_settime(fd_timer4, 0, &tval4, NULL) == -1) return false;
	ev.data.fd = fd_timer4;
	ev.events = EPOLLIN | EPOLLET;
	if(epoll_ctl(fd_epoll, EPOLL_CTL_ADD, fd_timer4, &ev) < 0) return false;
	epc++;
	}

if(fd_gpsd > 0)
	{
	ev.data.fd = fd_gpsd;
	ev.events = EPOLLIN | EPOLLET;
	if(epoll_ctl(fd_epoll, EPOLL_CTL_ADD, fd_gpsd, &ev) < 0) return false;
	epc++;
	}

scanlistcount = 0;
if(aktprotocol == IFTYPEWE)
	{
	if(set_ioctl_frequency() == false)
		{
		errorcount++;
		return false;
		}
	while(wantstopflag == false)
		{
		epn = epoll_pwait(fd_epoll, events, epc, FDMSECRX, &allsigs);
		if(epn == -1 && errno == EINTR) continue;
		else if(epn < -1)
			{
			errorcount++;
			if(errorcount > ERROR_MAX) wantstopflag = true;
			continue;
			}
		for(c = 0; c < epn; c++)
			{
			if(events[c].data.fd == fd_socket_rx) process_packet();
			else if(events[c].data.fd == fd_timer1)
				{
				read(fd_timer1, &exp, sizeof(u64));
//				printf("debug BEACON\n");
				}
			else if(events[c].data.fd == fd_timer2)
				{
				read(fd_timer2, &exp, sizeof(u64));
				gettimeofday(&tvakt, NULL);
				tsakt = ((u64)tvakt.tv_sec * 1000000ULL) + tvakt.tv_usec;
				if((tsakt - authseqakt.tsfirst) > STAYTIMEPLUS)
					{
					if(set_ioctl_frequency() == false) errorcount++;
					}
				}
			else if(events[c].data.fd == fd_timer3)
				{
				read(fd_timer3, &exp, sizeof(u64));
				if(gpiostatusled > 0)
					{
					GPIO_SET = 1 << gpiostatusled;
					nanosleep(&sleepled, NULL);
					GPIO_CLR = 1 << gpiostatusled;
					}
				if(gpiobutton > 0)
					{
					if(GET_GPIO(gpiobutton) > 0)
						{
						wantstopflag = true;
						if(gpiostatusled > 0) GPIO_SET = 1 << gpiostatusled;
						}
					}
				}
			else if(events[c].data.fd == fd_timer3)
				{
				read(fd_timer4, &exp, sizeof(u64));
				wantstopflag = true;
				totflag = true;
				}
			else if(events[c].data.fd == fd_gpsd) process_gpsd();
			}
		}
	}
else if(aktprotocol == IFTYPENL)
	{
	if(set_nl80211_frequency() == false)
		{
		errorcount++;
		return false;
		}
	while(wantstopflag == false)
		{
		epn = epoll_pwait(fd_epoll, events, epc, FDMSECRX, &allsigs);
		if(epn == -1 && errno == EINTR) continue;
		else if(epn < -1)
			{
			errorcount++;
			if(errorcount > ERROR_MAX) wantstopflag = true;
			continue;
			}
		for(c = 0; c < epn; c++)
			{
			if(events[c].data.fd == fd_socket_rx) process_packet();
			else if(events[c].data.fd == fd_timer1)
				{
				read(fd_timer1, &exp, sizeof(u64));
//				printf("debug BEACON\n");
				}
			else if(events[c].data.fd == fd_timer2)
				{
				read(fd_timer2, &exp, sizeof(u64));
				gettimeofday(&tvakt, NULL);
				tsakt = ((u64)tvakt.tv_sec * 1000000ULL) + tvakt.tv_usec;
				if((tsakt - authseqakt.tsfirst) > STAYTIMEPLUS)
					{
					if(set_nl80211_frequency() == false) errorcount++;
					}
				}
			else if(events[c].data.fd == fd_timer3)
				{
				read(fd_timer3, &exp, sizeof(u64));
				if(gpiostatusled > 0)
					{
					GPIO_SET = 1 << gpiostatusled;
					nanosleep(&sleepled, NULL);
					GPIO_CLR = 1 << gpiostatusled;
					}
				if(gpiobutton > 0)
					{
					if(GET_GPIO(gpiobutton) > 0)
						{
						wantstopflag = true;
						if(gpiostatusled > 0) GPIO_SET = 1 << gpiostatusled;
						}
					}
				}
			else if(events[c].data.fd == fd_timer3)
				{
				read(fd_timer4, &exp, sizeof(u64));
				wantstopflag = true;
				totflag = true;
				}
			else if(events[c].data.fd == fd_gpsd) process_gpsd();
			}
		}
	}
else return false;
if(fd_epoll != 0) close(fd_epoll);
if(fd_timer4 != 0) close(fd_timer4);
if(fd_timer3 != 0) close(fd_timer3);
if(fd_timer2 != 0) close(fd_timer2);
if(fd_timer1 != 0) close(fd_timer1);
return true;
}
/*===========================================================================*/
