/*===========================================================================*/
u16 frequency_to_channel(u32 frequency)
{
if(frequency == 2484) return 14;
else if(frequency < 2484) return (frequency - 2407) / 5;
else if(frequency >= 4910 && frequency <= 4980) return (frequency - 4000) / 5;
else if(frequency < 5925) return (frequency - 5000) / 5;
else if(frequency == 5935) return 2;
else if(frequency <= 45000) return (frequency - 5950) / 5;
else if(frequency >= 58320 && frequency <= 70200) return (frequency - 56160) / 2160;
else return 0;
}
/*---------------------------------------------------------------------------*/
u32 channel_to_frequency(u16 channel, u16 band)
{
if(channel <= 0) return 0;
switch(band)
	{
	case NL80211_BAND_2GHZ:
	if(channel == 14) return 2484;
	else if (channel < 14) return 2407 + (channel * 5);
	break;

	case NL80211_BAND_5GHZ:
	if(channel >= 182 && channel <= 196) return 4000 + (channel * 5);
	else return 5000 + channel * 5;
	break;

	case NL80211_BAND_6GHZ:
	if(channel == 2) return 5935;
	if(channel <= 233) return 5950 + (channel * 5);
	break;

	case NL80211_BAND_60GHZ:
	if(channel < 7) return 56160 + (channel * 2160);
	break;

	case NL80211_BAND_S1GHZ:
	return 902000 + (channel * 500);
	}
return 0;
}
/*---------------------------------------------------------------------------*/
static u32 get_frequency(u32 frequency)
{
size_t c;

for(c = 0; c < ifakt->cf; c++)
	{
	if(ifakt->frequency[c] == 0) continue;
	if(ifakt->frequency[c] == frequency) return frequency;
	}
return 0;
}
/*---------------------------------------------------------------------------*/
static bool init_scanlists(char *userfrequencylist)
{
size_t c;
char *tokptr = NULL;
char *userfrequencylistdupe = NULL;
char *userband = NULL;
u32 tmp = 0;
u32 frequency = 0;

memset(&scanlist, 0, sizeof(scanlist));
if(userfrequencylist == NULL)
	{
	for(c = 0; c < ifakt->cf; c++)
		{
		if(ifakt->frequency[c] == 0) continue;
		scanlist[c] = ifakt->frequency[c];
		if(c >= SCANLIST_MAX -1) break; 
		}
	scanlistcount = 0;
	return true;
	}
userfrequencylistdupe = strndup(userfrequencylist, SCANLIST_MAX);
if(userfrequencylistdupe == NULL) return false;
tokptr = strtok(userfrequencylistdupe, ",");

c = 0;
scanlistcount = 0;
while((tokptr != NULL) && (c < SCANLIST_MAX - 1))
	{
	tmp = strtol(tokptr, &userband, 10);
	if(tmp > 1000) frequency = get_frequency(tmp);
	else if(tmp > 0) 
		{
		if(userband[0] == 'a') frequency = channel_to_frequency(tmp, NL80211_BAND_2GHZ);
		else if(userband[0] == 'b') frequency = get_frequency(channel_to_frequency(tmp, NL80211_BAND_5GHZ));
		else if(userband[0] == 'c') frequency = get_frequency(channel_to_frequency(tmp, NL80211_BAND_6GHZ));
		else if(userband[0] == 'd') frequency = get_frequency(channel_to_frequency(tmp, NL80211_BAND_60GHZ));
		else if(userband[0] == 'e') frequency = get_frequency(channel_to_frequency(tmp, NL80211_BAND_S1GHZ));
		else frequency = 0;
		}
	if(frequency != 0) scanlist[c++] = frequency;
	else fprintf(stderr,"unsupported frequency, channel or band %s\n", tokptr);
	if(c >= SCANLIST_MAX -1) break;
	tokptr = strtok(NULL, ",");
	}
free(userfrequencylistdupe);
scanlistcount = 0;
return true;
}
/*---------------------------------------------------------------------------*/
static bool init_scanlist(char *userfrequencylist)
{
size_t c;
if(init_scanlists(userfrequencylist) == false) return false;

for( c = 0; c < SCANLIST_MAX; c++)
	{
	if(scanlist[c] == 0) break;
	scanlistchannel[c] = frequency_to_channel(scanlist[c]);
	}
return true;
}
/*===========================================================================*/
