/*===========================================================================*/
#define	MAC_SIZE_ACK		(10)
#define	MAC_SIZE_RTS		(16)
#define	MAC_SIZE_NORM		(24)
#define	MAC_SIZE_QOS		(26)
#define	MAC_SIZE_LONG		(30)
#define	MAC_SIZE_QOS_LONG	(32)

#define FCS_LEN 4

/* types */
#define IEEE80211_FTYPE_MGMT		0x0
#define IEEE80211_FTYPE_CTL		0x1
#define IEEE80211_FTYPE_DATA		0x2
#define IEEE80211_FTYPE_RCVD		0x3

/* management */
#define IEEE80211_STYPE_ASSOC_REQ	0x0
#define IEEE80211_STYPE_ASSOC_RESP	0x1
#define IEEE80211_STYPE_REASSOC_REQ	0x2
#define IEEE80211_STYPE_REASSOC_RESP	0x3
#define IEEE80211_STYPE_PROBE_REQ	0x4
#define IEEE80211_STYPE_PROBE_RESP	0x5
#define IEEE80211_STYPE_BEACON		0x8
#define IEEE80211_STYPE_ATIM		0x9
#define IEEE80211_STYPE_DISASSOC	0xa
#define IEEE80211_STYPE_AUTH		0xb
#define IEEE80211_STYPE_DEAUTH		0xc
#define IEEE80211_STYPE_ACTION		0xd
#define IEEE80211_STYPE_NACK		0xe
#define IEEE80211_STYPE_MGTRESERVED	0xf

/* control */
#define IEEE80211_STYPE_VHT		0x5
#define IEEE80211_STYPE_CTL_EXT		0x6
#define IEEE80211_STYPE_BACK_REQ	0x8
#define IEEE80211_STYPE_BACK		0x9
#define IEEE80211_STYPE_PSPOLL		0xa
#define IEEE80211_STYPE_RTS		0xb
#define IEEE80211_STYPE_CTS		0xc
#define IEEE80211_STYPE_ACK		0xd
#define IEEE80211_STYPE_CFEND		0xe
#define IEEE80211_STYPE_CFENDACK	0xf

/* data */
#define IEEE80211_STYPE_DATA			0x0
#define IEEE80211_STYPE_DATA_CFACK		0x1
#define IEEE80211_STYPE_DATA_CFPOLL		0x2
#define IEEE80211_STYPE_DATA_CFACKPOLL		0x3
#define IEEE80211_STYPE_NULLFUNC		0x4
#define IEEE80211_STYPE_CFACK			0x5
#define IEEE80211_STYPE_CFPOLL			0x6
#define IEEE80211_STYPE_CFACKPOLL		0x7
#define IEEE80211_STYPE_QOS_DATA		0x8
#define IEEE80211_STYPE_QOS_DATA_CFACK		0x9
#define IEEE80211_STYPE_QOS_DATA_CFPOLL		0xa
#define IEEE80211_STYPE_QOS_DATA_CFACKPOLL	0xb
#define IEEE80211_STYPE_QOS_NULLFUNC		0xc
#define IEEE80211_STYPE_QOS_CFACK		0xd
#define IEEE80211_STYPE_QOS_CFPOLL		0xe
#define IEEE80211_STYPE_QOS_CFACKPOLL		0xf

/* Reason codes (IEEE 802.11-2007, 7.3.1.7, Table 7-22) */
#define WLAN_REASON_UNSPECIFIED 1 /* ok */
#define WLAN_REASON_PREV_AUTH_NOT_VALID 2
#define WLAN_REASON_DEAUTH_LEAVING 3
#define WLAN_REASON_DISASSOC_DUE_TO_INACTIVITY 4
#define WLAN_REASON_DISASSOC_AP_BUSY 5
#define WLAN_REASON_CLASS2_FRAME_FROM_NONAUTH_STA 6 /* ok */
#define WLAN_REASON_CLASS3_FRAME_FROM_NONASSOC_STA 7  /* ok */
#define WLAN_REASON_DISASSOC_STA_HAS_LEFT 8
#define WLAN_REASON_STA_REQ_ASSOC_WITHOUT_AUTH 9
/* IEEE 802.11h */
#define WLAN_REASON_PWR_CAPABILITY_NOT_VALID 10
#define WLAN_REASON_SUPPORTED_CHANNEL_NOT_VALID 11
/* IEEE 802.11i */
#define WLAN_REASON_INVALID_IE 13
#define WLAN_REASON_MICHAEL_MIC_FAILURE 14
#define WLAN_REASON_4WAY_HANDSHAKE_TIMEOUT 15
#define WLAN_REASON_GROUP_KEY_UPDATE_TIMEOUT 16
#define WLAN_REASON_IE_IN_4WAY_DIFFERS 17
#define WLAN_REASON_GROUP_CIPHER_NOT_VALID 18
#define WLAN_REASON_PAIRWISE_CIPHER_NOT_VALID 19
#define WLAN_REASON_AKMP_NOT_VALID 20
#define WLAN_REASON_UNSUPPORTED_RSN_IE_VERSION 21
#define WLAN_REASON_INVALID_RSN_IE_CAPAB 22
#define WLAN_REASON_IEEE_802_1X_AUTH_FAILED 23
#define WLAN_REASON_CIPHER_SUITE_REJECTED 24

#define IEEE80211_SEQ_SEQ_MASK	0xfff0
#define IEEE80211_SEQ_SEQ_SHIFT	4

#define WBIT(n) (1 << (n))
#define WPA_KEY_INFO_TYPE_MASK (WBIT(0) | WBIT(1) | WBIT(2))
#define WPA_KEY_INFO_TYPE_HMAC_MD5_RC4 WBIT(0)
#define WPA_KEY_INFO_TYPE_HMAC_SHA1_AES WBIT(1)
#define WPA_KEY_INFO_KEY_TYPE WBIT(3) /* 1 = Pairwise, 0 = Group key */
#define WPA_KEY_INFO_KEY_INDEX_MASK (WBIT(4) | WBIT(5))
#define WPA_KEY_INFO_KEY_INDEX_SHIFT 4
#define WPA_KEY_INFO_INSTALL WBIT(6)  /* pairwise */
#define WPA_KEY_INFO_TXRX WBIT(6) /* group */
#define WPA_KEY_INFO_ACK WBIT(7)
#define WPA_KEY_INFO_MIC WBIT(8)
#define WPA_KEY_INFO_SECURE WBIT(9)
#define WPA_KEY_INFO_ERROR WBIT(10)
#define WPA_KEY_INFO_REQUEST WBIT(11)
#define WPA_KEY_INFO_ENCR_KEY_DATA WBIT(12) /* IEEE 802.11i/RSN only */
/*===========================================================================*/
typedef struct __attribute__((__packed__))
{
 u8	category;
#define RADIO_MEASUREMENT	5
 u8	action;
#define NEIGHBOR_REPORT_REQUEST	4
 u8	dialog;
}action_t;
#define	ACTION_SIZE (sizeof(action_t))
/*---------------------------------------------------------------------------*/
typedef struct __attribute__((__packed__))
{
 u8	id;
#define TAG_SSID	0x00
#define TAG_RATE	0x01
#define TAG_CHAN	0x03
#define TAG_COUNTRY	0x07
#define TAG_RSN		0x30
#define TAG_PAG		0xde
#define TAG_VENDOR	0xdd
 u8 	len;
 u8	data[1];
}ietag_t;
#define	IETAG_SIZE offsetof(ietag_t, data)
/*---------------------------------------------------------------------------*/
typedef struct __attribute__((__packed__))
{
 u16	capabilities;
 u16	listeninterval;
}capclient_t;
#define	CAPABILITIESCLIENT_SIZE sizeof(capclient_t)
/*---------------------------------------------------------------------------*/
typedef struct __attribute__((__packed__))
{
 u64	timestamp;
 u16	beaconintervall;
 u16	capabilities;
}capap_t;
#define	CAPABILITIESAP_SIZE sizeof(capap_t)
/*---------------------------------------------------------------------------*/
typedef struct __attribute__((__packed__))
{
 u8	control;
 u8	flags;
}qos_t;
#define	QOS_SIZE (sizeof(qos_t))
/*---------------------------------------------------------------------------*/
typedef struct __attribute__((__packed__))
{
 u8	dsap;
 u8	ssap;
 u8	control;
 u8	org[3];
 u16	type;
#define LLC_TYPE_AUTH	0x888e
#define LLC_TYPE_IPV4	0x0800
#define LLC_TYPE_IPV6	0x86dd
#define LLC_TYPE_PREAUT	0x88c7
#define LLC_TYPE_FRRR	0x890d
}llc_t;
#define	LLC_SIZE (sizeof(llc_t))
#define	LLC_SNAP 0xaa
/*---------------------------------------------------------------------------*/
typedef struct __attribute__((__packed__))
{
 u8	version;
 u8	type;
#define EAP_PACKET 0
#define EAPOL_START 1
#define EAPOL_LOGOFF 2
#define EAPOL_KEY 3
#define EAPOL_ASF 4
#define EAPOL_MKA 5
 u16	len;
 u8	data[1];
}eapauth_t;
#define	EAPAUTH_SIZE offsetof(eapauth_t, data)
/*---------------------------------------------------------------------------*/
#define M1	1
#define M2	2
#define M3	3
#define M4	4

typedef struct __attribute__((__packed__))
{
 u8	keydescriptor;
 u16	keyinfo;
 u16	keylen;
 u64	replaycount;
 u8	nonce[32];
 u8	keyiv[16];
 u64	keyrsc;
 u8	keyid[8];
 u8	keymic[16];
 u16	wpadatalen;
 u8	data[1];
}wpakey_t;
#define	WPAKEY_SIZE offsetof(wpakey_t, data)
/*---------------------------------------------------------------------------*/
typedef struct __attribute__((__packed__))
{
 u8	id;
 u8	len;
 u8	oui[3];
 u8	type;
 u8	pmkid[16];
}pmkid_t;
#define	PMKID_SIZE (sizeof(pmkid_t))
/*---------------------------------------------------------------------------*/
typedef struct __attribute__((__packed__))
{
 u16	version;
}iersn_t;
#define	IERSN_SIZE sizeof(iersn_t)
#define IERSN_LEN_MIN	20
/*---------------------------------------------------------------------------*/
typedef struct __attribute__((__packed__))
{
 u8	oui[3];
#define TKIP	2;
#define CCMP	4;
 u8	type;
}rsnsuite_t;
#define	RSNSUITE_SIZE sizeof(rsnsuite_t)
/*===========================================================================*/
/* DS bit usage
 *
 * TA = transmitter address
 * RA = receiver address
 * DA = destination address
 * SA = source address
 *
 * ToDS    FromDS  A1(RA)  A2(TA)  A3      A4      Use
 * -----------------------------------------------------------------
 *  0       0       DA      SA      BSSID   -       IBSS/DLS
 *  0       1       DA      BSSID   SA      -       AP -> STA
 *  1       0       BSSID   SA      DA      -       AP <- STA
 *  1       1       RA      TA      DA      SA      unspecified (WDS)
 */
typedef struct __attribute__((__packed__))
{
#ifdef BIG_ENDIAN_HOST
 unsigned	subtype : 4;
 unsigned	type : 	2;
 unsigned	version : 2;

 unsigned	ordered : 1;
 unsigned	prot : 1;
 unsigned	more_data : 1;
 unsigned	power : 1;
 unsigned	retry : 1;
 unsigned	more_frag : 1;
 unsigned	from_ds : 1;
 unsigned	to_ds : 1;
#else
 unsigned	version : 2;
 unsigned	type : 	2;
 unsigned	subtype : 4;

 unsigned	to_ds : 1;
 unsigned	from_ds : 1;
 unsigned	more_frag : 1;
 unsigned	retry : 1;
 unsigned	power : 1;
 unsigned	more_data : 1;
 unsigned	prot : 1;
 unsigned	ordered : 1;
#endif
 u16	duration;
 u8	addr1[6];
 u8	addr2[6];
 u8	addr3[6];
 u16	sequence;
 u8	addr4[6];
 qos_t	qos;
} mac_t;
/*===========================================================================*/
static rt_t *rth = NULL;
static ssize_t packetlen = 0;
static u8 *packetptr = NULL;
static u16 ieee82011len = 0;
static u8 *ieee82011ptr = NULL;
static mac_t *macfrx = NULL;
static u16 payloadlen = 0;
static u8 *payloadptr = NULL;
static u8 *llcptr = NULL;
static llc_t *llc = NULL;

static wpakey_t *wpakey;

static u16 eapauthlen;
static eapauth_t *eapauth;

static u16 eapauthpllen = 0;
static u8 *eapauthplptr = NULL;

static u16 eapolpllen = 0;
static u8 *eapolplptr = NULL;

static aplist_t *aplist;
static aplist_t *proberesponselist;

static u8 *packetoutptr = NULL;
static u16 seqcounter1 = 1;

static bool deauthenticationflag = true;

static u8 epbown[PCAPNG_SNAPLEN *2] = { 0 };
static u8 epb[PCAPNG_SNAPLEN *2] = { 0 };

static const u8 zeroed[] =
{
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

static const u8 macbc[] =
{
0xff, 0xff, 0xff, 0xff, 0xff, 0xff
};

static const u8 rsnsuiteoui[3] =
{
0x00, 0x0f, 0xac
};
/*===========================================================================*/

